#include <reg552.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

//https://cs.wikipedia.org/wiki/Algoritmus_pro_v%C3%BDpo%C4%8Det_dne_v_t%C3%BDdnu

typedef struct _Datum
{
	unsigned char q,m,J,K;
}
Datum_t;

typedef struct _datum
{
	unsigned char q,m;
	unsigned int Y;
}
datum_t;

Datum_t DateR = {28,4,19,71};
datum_t DateL = {28,4,1971};

unsigned char Gregorian0(Datum_t Date)
{
	switch(Date.m)
		{
			case	1	:	
			case	2	:	Date.m+=12;	Date.K--;
			default	:	return(((((Date.q+(13*(Date.m+1)/5)+Date.K+(Date.K/4)+(Date.J/4)+(5*Date.J))%7)+5)%7)+1);	break;
		}	
}

unsigned char Gregorian1(datum_t Date)
{
	unsigned char J,K;
	J=Date.Y/100;
	K=Date.Y%100;
	switch(Date.m)
		{
			case	1	:	
			case	2	:	Date.m+=12;	K--;
			default	:	return(((((Date.q+(13*(Date.m+1)/5)+K+(K/4)+(J/4)+(5*J))%7)+5)%7)+1);	break;
		}	
}

unsigned char Gregorian2(char Den,char Mes,int Rok)
{
	switch(Mes)
		{
			case	1		:
			case	2		:	Mes+=12; Rok--;
			default		:	return(((((Den+(13*(Mes+1)/5)+(Rok%100)+((Rok%100)/4)+((Rok/100)/4)+(5*(Rok/100)))%7)+5)%7)+1);	break;
		}
}

unsigned char Gregorian3(char Den,char Mes,int Rok)		//Vhodne pre PC a jazyk C !!!
{
	switch(Mes)
		{
			case	1		:
			case	2		:	Mes+=12; Rok--;
			default		:	return(((((Den+(((Mes+1)*26)/10)+Rok+(Rok/4)+6*(Rok/100)+(Rok/400))%7)+5)%7)+1);	break;
		}
}

typedef struct
{
 unsigned char Hod,Min,Sek,Mes,Den;
 int Rok;
}
Time;

unsigned char d;
Time Cas;

void main(void)
{
 int argsread;
	code unsigned char *SystemTime[]={__TIME__,__DATE__,__DATE2__,__C51__};
  argsread=sscanf(SystemTime[0],"%02bd:%02bd:%02bd",&Cas.Hod,&Cas.Min,&Cas.Sek);
	argsread=sscanf(SystemTime[2],"%02bd/%02bd/%04d",&Cas.Mes,&Cas.Den,&Cas.Rok);
	d=Gregorian3(Cas.Den,Cas.Mes,Cas.Rok+=2000);	//Today
	for(;;)
		{
			d=Gregorian0(DateR);
			d=Gregorian1(DateL);
			d=Gregorian2(DateL.q,DateL.m,DateL.Y);
			d=Gregorian3(DateL.q,DateL.m,DateL.Y);
			d=Gregorian3(31,3,1945);
			d=Gregorian3(16,1,1949);
			d=Gregorian3(20,4,1969);
			d=Gregorian3(28,4,1971);
		}
}